include<LX15D/tiles.scad>;
include<LX15D/cables.scad>;
include<camera.scad>;
include<metric.scad>;
include<util.scad>;
include<tile.scad>;
include<LX15D.scad>;
include<bat.scad>;

screw_d = 3;
t = 3;
middle_t = Ta(T24);

xplate_h = Ta(T24) / 2;
xplate_tile_h = 6;
xplate_w = Ta(T24) * 2;
xplate_l = Ta(T24) * 7;

module body_collision(positions) {
	hull() for (pos = positions) {
		translate(pos)
		    cube([ LX15D_dim[1], LX15D_dim[1], LX15D_horn_w ],
			 center = true);
	}
	cube([ xplate_l, xplate_w, xplate_h * 2 + xplate_tile_h * 2 ],
	     center = true);
}

module spine() part("white") {
	for (i = [ -2.5 : 2.5 ]) translate([ i * Ta(T24), 0, Ta(T24) ]) tile_box(T24);
	for (i = [ -2.5 , 2.5 ]) translate([ i * Ta(T24), 0, 0 ]) tile_box(T24);
	// tile(T24, middle_t, center = true, centered_hole = true);
}

module servo_pos(coord) {
	translate(coord) if (coord[1] > 0) { rotate([ 0, 0, -90 ]) children(); }
	else {
		rotate([ 0, 0, 90 ]) children();
	}
}

module rpi4() part("darkgray") {
	translate([ -85 / 2, -56 / 2, 0 ]) import("rpi4.stl");
}
module nucleo() part("white") {
	translate([ -43.2 / 2, -17.8 / 2, 0 ]) import("nucleo.stl");
}

module body(positions, expand = 0) {
//	translate([0, -Ta(T24), 0])
//		rotate([0, 0, 90]) bat_set();
//	translate([0, Ta(T24), 0])
//		rotate([0, 0, 90]) bat_set();
	

	for (pos = positions) servo_pos(pos) {
			rotate([ 180, 0, 0 ])
			    LX15D_cable_holder_B(z_offset = 2, expand = expand);
			translate([ -4 * expand, 0, 0 ]) LX15D();
			translate([ -2 * expand, 0, 0 ])
			    LX15D_U(T24, expand = expand);
		}
	// translate([ 0, 0, 3 * expand ]) finalize("green") top_xplate();
	// translate([ 0, 0, -3 * expand ]) finalize("green") bottom_xplate();

	translate([ -120, 0, 30 ]) rotate([ 0, 0, 180 ]) rpi4();
	for (i = [ -1, 1 ])
		for (j = [ -1, 1 ])
			translate([ i * 24, j * 24, 5 ]) nucleo();
	spine();
	translate([ 140, 0, 25 ]) {
//		D415();
//		        D415_fov();
	}
}
